﻿using PDF_Office.CustomControl;
using PDF_Office.Helper;
using PDF_Office.Model.PDFTool;
using PDF_Office.ViewModels.HomePanel;
using PDF_Office.Views.HomePanel.PDFTools;
using PDFSettings;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace PDF_Office.Views.HomePanel.PDFTools
{
    /// <summary>
    /// HomeToolIControl.xaml 的交互逻辑0
    /// 
    /// </summary>
    public partial class QuickToolsContent : UserControl
    {
        PDFToolsHelper PDFtools;
        public QuickToolsContent()
        {
            InitializeComponent();
            PDFtools = PDFToolsHelper.GetInstance();
            ListBoxToolBars.ItemsSource = PDFtools.QuickTools;
        }
   

        private void BtnMore_Click(object sender, RoutedEventArgs e)
        {
        }

        private void BtnExptend_Click(object sender, RoutedEventArgs e)
        {
            UpdateExptendUI();
        }

        private void UpdateExptendUI()
        {
            if ((bool)BtnExptend.IsChecked)
            {
                GridAllTools.Height = 270;
            }
            else
            {
                GridAllTools.Height = 174;
            }

            foreach (var item in PDFtools.QuickTools)
            {
                item.IsShowConciseContent = !(bool)BtnExptend.IsChecked;
            }
        }



        /// <summary>
        /// 编辑工具
        /// </summary>
        private void BtnTools_Click(object sender, RoutedEventArgs e)
        {
           
        }

        private void GridAllTools_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            ListBoxToolBarsWidthChanged();
        }


        private void ListBoxToolBarsWidthChanged()
        {
            double containerWidth = ListBoxToolBars.ActualWidth - 20;
            int widthItem = (int)containerWidth / 5;
            double margin = widthItem / 3;

            int i = 0;
            foreach (var item in ListBoxToolBars.Items)
            {
                i++;
                var listBoxItem = ListBoxToolBars.ItemContainerGenerator.ContainerFromItem(item) as ListBoxItem;
                if (listBoxItem != null)
                {
                    if (i % 4 != 0)
                    {
                        listBoxItem.Margin = new Thickness(0, 0, margin, 0);

                    }
                    else
                    {
                        listBoxItem.Margin = new Thickness(0, 0, 0, 0);
                    }
                    listBoxItem.Width = widthItem;
                }
            }
        }

        private void ListBoxShortCuts_SizeChanged(object sender, SizeChangedEventArgs e)
        {
           
        }

        private void QuickTools_Click(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var toolItem = (sender as FrameworkElement).DataContext as ToolItem;
            var veiwModel = this.DataContext as HomeGuidContentViewModel;
            if (veiwModel != null && toolItem != null)
            {
                veiwModel.QuickToolsCommand.Execute(toolItem);
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            if(ListBoxToolBars.Items != null)
            {
                UpdateExptendUI();
                ListBoxToolBars.Items.Refresh();
                ListBoxToolBarsWidthChanged();
            }
           
        }
    }

}
